<?php
namespace PME\Modules\Planejamento\Prato;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;


class ConsultaNutrientes extends \PME\Services\TeknisaCrud {
	
	protected $crudService;
	protected $parameterBag;
	protected $entityManager;
	protected $connection;
	protected $environment;

    public function __construct($crudService, $parameterBag, $entityManager, $connection, $environment) {
      $this->entityManager = $entityManager;
      $this->connection = $connection;
      $this->environment = $environment;
      parent::__construct($crudService, $parameterBag);
    }

    public function procedureConsultaNutrientes(DTO\Request $request, DTO\Response $response){
	    $row = $request->getRow();
	    
      $connection = $this->entityManager->getConnection();
      $procedureCons = new StoredProcedure($connection, 'NDPCAL_DO_PRATO_PLA');
      
      $procedureCons->addParam(new Param('P_CDFILIAL',        Param::PARAM_INPUT, NULL,                 Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDFILIPROC',      Param::PARAM_INPUT, NULL,                 Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDSERVFILI',      Param::PARAM_INPUT, NULL,                 Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDFILAUXPRAT',    Param::PARAM_INPUT, $row['CDFILAUXPRAT'], Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDPRATO',         Param::PARAM_INPUT, $row['CDPRATO'],      Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDFILCENTPME',    Param::PARAM_INPUT, NULL,                 Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_CDTIPOCARD',      Param::PARAM_INPUT, NULL,                 Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_MERENDA',         Param::PARAM_INPUT, 'N',                  Param::PARAM_TYPE_STR));
      $procedureCons->addParam(new Param('P_NDPCAL_DO_PRATO', Param::PARAM_OUTPUT, NULL,                Param::PARAM_TYPE_STR, 10));
      $procedureCons->execute();

      $ndpcal = $procedureCons->execute()['P_NDPCAL_DO_PRATO'];
      $response->addDataSet(new DataSet("result", ["ndpcal" => $ndpcal]));
    }
}
