<?php
namespace Planejamento\Logic\Cardapio;

use \Planejamento\Entities\Sinasafra;

/**
 * Created by Erika Souza.
 * User: erikasouza
 * Date: 01/12/2014
 * Time: 09:44
 */
class Safra
{

    /**
     * Retorna a null ou cor em hexadecimal.
     *
     * @param integer $nrorg Numero da organizacao
     * @param integer $valor Valor percentual da safra total do prato
     *
     * @return mixed
     */
    public static function retornaCorSafraGeral($nrorg, $valor){
        /** @var Sinasafra $sinaSafra */
        $sinaSafra = Sinasafra::getObjectByWhere(
            'NRORG = ? AND (VRLIMINFSAFR <= ? AND VRLIMSUPSAFR >= ?)',
            array($nrorg, $valor, $valor)
        );

        if ($sinaSafra instanceof Sinasafra) {
            $cor = $sinaSafra->getNrcorsinsafr();
            $corHex = dechex($cor);
            $corHex = str_pad($corHex, 6 , 0, STR_PAD_LEFT);
            return '#'.$corHex;
        }

        return null;
    }

}
