IF EXISTS(SELECT NAME
         FROM SYSOBJECTS
        WHERE NAME = 'CTB_PAG_BAIXA' AND TYPE = 'P')
DROP PROCEDURE CTB_PAG_BAIXA
GO

CREATE PROCEDURE CTB_PAG_BAIXA
   @P_NRLANCCTBTEMP VARCHAR(12),
   @P_CDEMPRESA VARCHAR(02),
   @P_CDFILIAL VARCHAR(04),
   @P_NRBAIXA VARCHAR(10),
   @P_NRLANCCTB VARCHAR(12) OUTPUT
AS
   DECLARE @V_DTBAIXA DATETIME;
   DECLARE @V_CDREDUCONT VARCHAR(03);
   DECLARE @V_CDTPBAIXA VARCHAR(02);
   DECLARE @V_VRBAIXAPAG FLOAT;
   DECLARE @V_DOCUMENTO VARCHAR(10);
   DECLARE @V_STATUS VARCHAR(01);
   DECLARE @V_CONTABILIZA VARCHAR(01);
   DECLARE @V_IDBAIXAUTILP VARCHAR(01);
   DECLARE @V_NMTPBAIXAPAG VARCHAR(50);

   DECLARE @V_CONTAJUST INT;
   DECLARE @V_DATAAUX VARCHAR(20);
   DECLARE @V_NRLANCTEMP VARCHAR(20);
   DECLARE @V_CONTRAT VARCHAR(01);
   DECLARE @V_CDHISTINT VARCHAR(04);
   DECLARE @V_DSHISTINT VARCHAR(200);
   DECLARE @V_CDHISTPADR VARCHAR(04);
   DECLARE @V_CDCENTCUST VARCHAR(04);
   DECLARE @V_CDFILIAL VARCHAR(04);
   DECLARE @V_DSHISTPADR VARCHAR(200);
   DECLARE @V_SEQPARTIDA INT;
   DECLARE @V_PARTIDAAUX VARCHAR(05);
   DECLARE @V_VRPARTIDA FLOAT;
   DECLARE @V_RATSEQ INT;
   DECLARE @V_IDCOME VARCHAR(01);
   DECLARE @V_IDCCUS VARCHAR(01);
   DECLARE @V_RATSEQAUX VARCHAR(05);
   DECLARE @V_CDCONTCTBL VARCHAR(20);
   DECLARE @V_CDFILIALBOL VARCHAR(04);
   DECLARE @V_NRLANBOLPAG VARCHAR(10);
   DECLARE @V_CODCOMEAUX VARCHAR(21);
   DECLARE @V_VRTOTALAJUSNCTB FLOAT;
   DECLARE @V_ENTROULOOP VARCHAR(01);
   DECLARE @V_FATOR INT;

   /* VARIAVEIS DO CURSOR C_CONTAS */
   DECLARE @C_CONTAS_CDFILIAL VARCHAR(04);
   DECLARE @C_CONTAS_NRLANCTONF VARCHAR(10);
   DECLARE @C_CONTAS_NRSEQVENPAG VARCHAR(02);
   DECLARE @C_CONTAS_NRPARCELAPAG VARCHAR(02);
   DECLARE @C_CONTAS_CDFILBOL VARCHAR(04);
   DECLARE @C_CONTAS_NRLANBOLPAG VARCHAR(10);
   DECLARE @C_CONTAS_CDFORNECED VARCHAR(21);
   DECLARE @C_CONTAS_CDTPCTPAGAR VARCHAR(06);
   DECLARE @C_CONTAS_CDCONTCTBL VARCHAR(20);
   DECLARE @C_CONTAS_CDHISTPADR VARCHAR(04);
   DECLARE @C_CONTAS_DSHISTPADR VARCHAR(200);
   DECLARE @C_CONTAS_CDFILIRECE VARCHAR(04);
   DECLARE @C_CONTAS_NRNOTAFISC VARCHAR(20);
   DECLARE @C_CONTAS_VRATUAPAG FLOAT;
   DECLARE @C_CONTAS_IDCTBTPCNTBPAG VARCHAR(01);
   DECLARE @C_CONTAS_VRBOLPAG FLOAT;
   DECLARE @C_CONTAS_QTCONTAS INT;
   DECLARE @C_CONTAS_IDTPCTPAGAR VARCHAR(01);
   DECLARE @C_CONTAS_CDEMPRESA   VARCHAR(02);
   DECLARE @C_CONTAS_VRORIGPAG   FLOAT;

   /* VARIAVEIS DO CURSOR C_RATEIO */
   DECLARE @C_RATEIO_CDCENTCUST VARCHAR(04);
   DECLARE @C_RATEIO_CDFIRATCTPAG VARCHAR(04);
   DECLARE @C_RATEIO_VRRATCCCTPAG FLOAT;

   /* VARIAVEIS DO CURSOR AJUSTE */
   DECLARE @AJUSTES_NRLANBOLPAG VARCHAR(10);
   DECLARE @AJUSTES_CDFILIBAIPAG VARCHAR(04);
   DECLARE @AJUSTES_CDFILIRECE VARCHAR(04);
   DECLARE @AJUSTES_CDAJUCTPAG VARCHAR(04);
   DECLARE @AJUSTES_CDREDUCONT VARCHAR(03);
   DECLARE @AJUSTES_CDFORNECED VARCHAR(21);
   DECLARE @AJUSTES_VRAJBOLPAG FLOAT;
   DECLARE @AJUSTES_IDAJUCTPAG VARCHAR(01);
   DECLARE @AJUSTES_VRBOLPAG FLOAT;
   DECLARE @AJUSTES_NRLANCTONF VARCHAR(10);
   DECLARE @AJUSTES_CDFILIAL VARCHAR(04);
   DECLARE @AJUSTES_CDHISTPADR VARCHAR(04);
   DECLARE @AJUSTES_NRSEQVENPAG VARCHAR(02);
   DECLARE @AJUSTES_NRPARCELAPAG VARCHAR(02);
   DECLARE @AJUSTES_VRATUAPAG FLOAT;
   DECLARE @AJUSTES_CDCONTCTBL VARCHAR(20);

   DECLARE @V_VRAJUSTE FLOAT;
   DECLARE @V_COUNT INT;
   DECLARE @V_NRCONTABOL INT;
   DECLARE @V_VRSOMAAJUSNCTB FLOAT;
   DECLARE @V_VRAJUSNCTB FLOAT;
   DECLARE @V_TOTALRATEIO FLOAT;
   DECLARE @V_TOTAJUSTE FLOAT;
   DECLARE @V_TOTRATAJ FLOAT;


   /* VARIAVEIS DO CURSOR RATAJ */
   DECLARE @RATAJ_CDCENTCUST VARCHAR(04);
   DECLARE @RATAJ_CDFIRATTpajp VARCHAR(04);
   DECLARE @RATAJ_CDFILIAL VARCHAR(04);
   DECLARE @RATAJ_VRPERATTpajp FLOAT;
   DECLARE @V_VRCONTA FLOAT;

   DECLARE @V_DSHISTLANC VARCHAR(200);
   DECLARE @V_CDHISTLANC VARCHAR(04);

BEGIN
   SELECT @V_DTBAIXA = DTBAIXAPAG, @V_CDREDUCONT = CDREDUCONT, @V_CDTPBAIXA = BX.CDTPBAIXAPAG,
          @V_VRBAIXAPAG = VRBAIXAPAG, @V_DOCUMENTO = NRBAIXAPAG, @V_STATUS = IDSTATUSBPAG,
          @V_CONTABILIZA = IDCTBLBXPAG, @V_IDBAIXAUTILP =  T.IDBAIXAUTILP, @V_NMTPBAIXAPAG = T.NMTPBAIXAPAG
     FROM BAIXAPAGA BX, TIPOBAIXAPAG T
    WHERE BX.CDFILIAL = @P_CDFILIAL
       AND BX.CDEMPRESA = @P_CDEMPRESA
       AND BX.NRBAIXAPAG = @P_NRBAIXA
       AND T.CDTPBAIXAPAG = BX.CDTPBAIXAPAG;

   SELECT @V_COUNT = COUNT(*)
     FROM PARAMCTBL
    WHERE @V_DTBAIXA >= DTINTCTBPAG;

   IF @V_COUNT > 0 BEGIN
      SELECT @V_CONTAJUST = COUNT(*)
        FROM BOLETPAGAR BO, AJBOLPAG AJ, TIPOAJPAGAR TP
       WHERE BO.CDFILIBAIPAG = @P_CDFILIAL
         AND BO.NRBAIXAPAG = @P_NRBAIXA
         AND BO.NRLANBOLPAG = AJ.NRLANBOLPAG
         AND BO.CDFILIAL = AJ.CDFILIAL
         AND AJ.CDAJUCTPAG = TP.CDAJUCTPAG
         AND TP.IDCTBAJCTPAG = 'S';

      IF ((@V_STATUS <> 'P') AND (@V_CONTABILIZA <> 'N')) BEGIN
         /* CASO O PARAMETRO DE NMERO DE LANAMENTO CONTBIL NO SEJA NULO,  PORQUE O LANAMENTO J EXISTIA.
            TENDO ASSIM QUE APAGAR O LANAMENTO PARA REFAZ-LO NA ROTINA                                    */
         IF @P_NRLANCCTBTEMP IS NOT NULL BEGIN
            /* DELETA OS RATEIOS DO LANAMENTO CONTBIL */
            DELETE
              FROM LANCCCUSTO
             WHERE NRLANCCONT = @P_NRLANCCTBTEMP
               AND CDEMPRESA  = @P_CDEMPRESA;

            /* DELETA AS PARTIDAS DO LANAMENTO CONTBIL */
            DELETE
              FROM LANCCONT
             WHERE NRLANCCONT = @P_NRLANCCTBTEMP
               AND CDEMPRESA  = @P_CDEMPRESA;
         END;

         SET @V_NRLANCTEMP = @P_NRLANCCTBTEMP;

         /* CASO A VARIVEL QUE RECEBE O NMERO DO LANAMENTO CONTBIL SEJA NULA,  PORQUE O LANAMENTO CONTBIL  NOVO. */
         IF @V_NRLANCTEMP IS NULL BEGIN
            /* PEGA UM NOVO NMERO DE LANAMENTO CONTBIL, CASO O LANAMENTO NO PAG SEJA NOVO */
            SET @V_DATAAUX = SUBSTRING(CONVERT(VARCHAR, @V_DTBAIXA, 103), 7, 4) + SUBSTRING(CONVERT(VARCHAR, @V_DTBAIXA, 103), 4, 2);
            SET @V_DATAAUX = 'LANCCONTABIL' + @P_CDEMPRESA + @V_DATAAUX;

            EXEC NOVO_CODIGO @V_DATAAUX, @P_SEQUENCIAL = @V_NRLANCTEMP OUTPUT;
            SET @V_DATAAUX = SUBSTRING(CONVERT(VARCHAR, @V_DTBAIXA, 103), 7, 4) + SUBSTRING(CONVERT(VARCHAR, @V_DTBAIXA, 103), 4, 2);
            SET @V_NRLANCTEMP = @V_DATAAUX + SUBSTRING(@V_NRLANCTEMP, 15, 6);
         END;

         IF (@V_VRBAIXAPAG <> 0 OR @V_CONTAJUST <> 0) BEGIN
            SELECT @V_CONTRAT = IDCONTGERE
              FROM CONTOPECTBL
             WHERE CDEMPRESA = @P_CDEMPRESA;

            SELECT @V_CDHISTINT = H.CDHISTPADR, @V_DSHISTINT = HP.DSHISTPADR
              FROM HISTINTEGRA H, HISTPADR HP
             WHERE H.CDHISTPADR = HP.CDHISTPADR
               AND CDOPERACAO = 'BAIXAP';

            /* SELECIONA O HISTRICO PADRO RELACIONADO  BAIXA */
            SELECT @V_CDHISTPADR = T.CDHISTPADR, @V_DSHISTPADR = H.DSHISTPADR
              FROM TIPOBAIXAPAG T, HISTPADR H
             WHERE T.CDTPBAIXAPAG = @V_CDTPBAIXA
               AND T.CDHISTPADR   = H.CDHISTPADR;

            IF @V_CDHISTPADR IS NULL BEGIN
               SET @V_CDHISTPADR = @V_CDHISTINT;
               SET @V_DSHISTPADR = @V_DSHISTINT;
            END;
            SET @V_SEQPARTIDA = 0;

            IF @V_VRBAIXAPAG <> 0 BEGIN
               SELECT @V_CDCONTCTBL = CC.CDCONTCTBL
                 FROM CONTCORR CC
                WHERE CC.CDREDUCONT = @V_CDREDUCONT;

               SELECT @V_IDCOME = ISNULL(IDTIPOCOME, 'N'), @V_IDCCUS = IDCONTCCUS
                 FROM CONTCTBL
                WHERE CDCONTCTBL = @V_CDCONTCTBL;

               IF @V_IDCOME <> 'B' BEGIN
                  SET @V_IDCOME = 'N';
                  SET @V_CDREDUCONT = NULL;
               END;

               IF @V_IDBAIXAUTILP IN ('A', 'M') BEGIN
                  SET @V_DSHISTLANC = 'Cheque: [#CHQ]';
               END
               ELSE BEGIN
                  SET @V_DSHISTLANC = 'PGTO ' +  SUBSTRING(@V_NMTPBAIXAPAG, 1, 30);
               END;

               SET @V_SEQPARTIDA = @V_SEQPARTIDA + 1;
               SET @V_PARTIDAAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_SEQPARTIDA), 2);
               SET @V_VRPARTIDA = ROUND(@V_VRBAIXAPAG, 2);
               INSERT INTO LANCCTBTEMP
                  (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                   DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
               VALUES
                  (@P_CDEMPRESA, @V_NRLANCTEMP, @V_DOCUMENTO, @V_PARTIDAAUX, @V_CDCONTCTBL, @V_CDHISTPADR,
                   @V_DSHISTLANC, @V_DTBAIXA, @V_VRPARTIDA, @V_IDCOME, @V_CDREDUCONT, 'PAG');

               IF @V_CONTRAT = 'S' BEGIN
                  IF @V_IDCCUS <> 'O' BEGIN
                     SET @V_RATSEQ = @V_RATSEQ + 1;
                     SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);
                     SET @V_VRPARTIDA = ROUND(@V_VRBAIXAPAG, 2);

                     IF @V_CDCENTCUST IS NULL BEGIN
                        SELECT @V_CDCENTCUST = CDCENTCUST
                          FROM EMPRESA
                         WHERE CDEMPRESA = @P_CDEMPRESA;
                     END;

                     INSERT INTO RATECTBTEMP
                        (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                     VALUES
                        (@P_CDEMPRESA, @V_NRLANCTEMP, @V_PARTIDAAUX, @P_CDFILIAL, @V_CDCENTCUST,
                         @V_VRPARTIDA, @V_DTBAIXA, @V_RATSEQAUX);
                  END;
               END;

               SET @V_CDFILIALBOL = 'XXXX';
               SET @V_NRLANBOLPAG = 'XXXXXXXXXX';

               DECLARE C_CONTAS CURSOR FOR
                  SELECT CT.CDFILIAL, CT.NRLANCTONF, CT.NRSEQVENPAG, CT.NRPARCELAPAG,
                         B.CDFILIAL AS CDFILBOL, B.NRLANBOLPAG, B.CDFORNECED, CT.CDTPCTPAGAR, TP.CDCONTCTBL,
                         TP.CDHISTPADR, H.DSHISTPADR, NF.CDFILIRECE, NF.NRNOTAFISC,
                         CT.VRATUAPAG,  IDCTBTPCNTBPAG, B.VRBOLPAG, COUNT(*) OVER(PARTITION BY B.CDFILIAL, B.NRLANBOLPAG) AS QTCONTAS,
                         TP.IDTPCTPAGAR, CT.CDEMPRESA, CT.VRORIGPAG
                    FROM BOLETPAGAR B, CONTAPAGAR CT, NOTAFISCAL NF, TIPOCTPAGAR TP LEFT JOIN HISTPADR H
                                                                                                 ON TP.CDHISTPADR = H.CDHISTPADR
                   WHERE B.CDFILIBAIPAG = @P_CDFILIAL
                     AND B.NRBAIXAPAG = @P_NRBAIXA
                     AND B.CDFILIAL = ct.CDFILIBPAG
                     AND B.NRLANBOLPAG = CT.NRLANBOLPAG
                     AND CT.CDFILIAL = NF.CDFILIAL
                     AND CT.NRLANCTONF = NF.NRLANCTONF
                     AND CT.CDTPCTPAGAR = TP.CDTPCTPAGAR
                   ORDER BY B.CDFILIAL, B.NRLANBOLPAG;
               OPEN C_CONTAS;
               FETCH NEXT FROM C_CONTAS INTO @C_CONTAS_CDFILIAL, @C_CONTAS_NRLANCTONF, @C_CONTAS_NRSEQVENPAG, @C_CONTAS_NRPARCELAPAG,
                                             @C_CONTAS_CDFILBOL, @C_CONTAS_NRLANBOLPAG, @C_CONTAS_CDFORNECED, @C_CONTAS_CDTPCTPAGAR, @C_CONTAS_CDCONTCTBL,
                                             @C_CONTAS_CDHISTPADR, @C_CONTAS_DSHISTPADR, @C_CONTAS_CDFILIRECE, @C_CONTAS_NRNOTAFISC,
                                             @C_CONTAS_VRATUAPAG, @C_CONTAS_IDCTBTPCNTBPAG, @C_CONTAS_VRBOLPAG, @C_CONTAS_QTCONTAS,
                                             @C_CONTAS_IDTPCTPAGAR, @C_CONTAS_CDEMPRESA, @C_CONTAS_VRORIGPAG;
               WHILE @@FETCH_STATUS = 0 BEGIN
                  IF @C_CONTAS_VRATUAPAG <> 0 BEGIN
                     SET @V_CDHISTLANC = @V_CDHISTPADR;
                     IF @C_CONTAS_IDTPCTPAGAR = '2' BEGIN /* TIPO DE CONTA "ADIANTAMENTO" */
                        SET @V_CDCONTCTBL = @C_CONTAS_CDCONTCTBL; /* CONTA CONTBIL DO TIPO DE CONTA */
                        SELECT @V_CDHISTLANC = H.CDHISTPADR, @V_DSHISTLANC = HP.DSHISTPADR
                          FROM HISTINTEGRA H ,HISTPADR HP
                         WHERE H.CDHISTPADR = HP.CDHISTPADR
                           AND CDOPERACAO = 'BXPADI';

                        IF @V_CDHISTLANC IS NULL BEGIN
                           SET @V_CDHISTLANC = @V_CDHISTPADR;
                           SET @V_DSHISTLANC = @V_DSHISTPADR;
                        END;
                        SET @V_VRCONTA = @C_CONTAS_VRATUAPAG * -1;
                     END
                     ELSE BEGIN
                        IF @C_CONTAS_IDCTBTPCNTBPAG = 'N' BEGIN /* NO CONTABILIZA POR TIPO DE CONTA NA BAIXA */
                           /* PEGA O HISTORICO DO TIPO DE BAIXA, CASO ESTEJA VAZAIO, PEGA O HISTORICO DE INTEGRAO.
                              ESTE HISTORICO J FOI PEGO NO COMEO DA PROCEDURE.                                     */
                           EXEC CTB_CCFORNECEDOR @C_CONTAS_CDFORNECED, @C_CONTAS_CDFILIRECE, @C_CONTAS_CDEMPRESA, @P_CDCONTCTBL = @V_CDCONTCTBL OUTPUT;
                           /* FUNCAO HISTORICO */
                           SET @V_VRCONTA = @C_CONTAS_VRORIGPAG * -1;
                        END
                        ELSE BEGIN /* SE CONTABILIZAR POR TIPO DE CONTA BA BAIXA */
                           IF @C_CONTAS_CDHISTPADR IS NOT NULL BEGIN
                              SET @V_CDHISTLANC = @C_CONTAS_CDHISTPADR;
                           END;
                           SET @V_CDCONTCTBL = @C_CONTAS_CDCONTCTBL;
                           SET @V_VRCONTA = @C_CONTAS_VRATUAPAG * -1;
                        END;
                     END;

                     /*ROTINA PARA RATEAR OS VALORES DOS AJUSTES QUE NO CONTABILIZAM */
                     IF (@V_CDFILIALBOL <> @C_CONTAS_CDFILBOL) OR
                        (@V_NRLANBOLPAG <> @C_CONTAS_NRLANBOLPAG) BEGIN

                        SELECT @V_VRTOTALAJUSNCTB = SUM(CASE TA.IDAJUCTPAG WHEN 'D' THEN AJ.VRAJBOLPAG * -1 ELSE AJ.VRAJBOLPAG END)
                          FROM AJBOLPAG AJ, TIPOAJPAGAR TA
                         WHERE AJ.CDFILIAL = @C_CONTAS_CDFILBOL
                           AND AJ.NRLANBOLPAG = @C_CONTAS_NRLANBOLPAG
                           AND AJ.CDAJUCTPAG = TA.CDAJUCTPAG
                           AND TA.IDCTBAJCTPAG = 'N';
                        IF @V_VRTOTALAJUSNCTB IS NULL BEGIN
                           SET @V_VRTOTALAJUSNCTB = 0;
                        END;
                        SET @V_NRCONTABOL = 1;
                        SET @V_VRSOMAAJUSNCTB = 0;
                        SET @V_VRAJUSNCTB = 0;
                        SET @V_CDFILIALBOL = @C_CONTAS_CDFILBOL;
                        SET @V_NRLANBOLPAG = @C_CONTAS_NRLANBOLPAG;
                     END
                     ELSE BEGIN
                        SET @V_NRCONTABOL = @V_NRCONTABOL +1;
                     END;
                     IF @V_VRTOTALAJUSNCTB <> 0 BEGIN
                        SET @V_VRAJUSNCTB = (@V_VRTOTALAJUSNCTB * 100) / @C_CONTAS_VRBOLPAG;
                        SET @V_VRAJUSNCTB = ROUND((@V_VRAJUSNCTB * @C_CONTAS_VRATUAPAG) / 100, 2);

                        SET @V_VRSOMAAJUSNCTB = @V_VRSOMAAJUSNCTB + @V_VRAJUSNCTB;

                        IF @V_NRCONTABOL = @C_CONTAS_QTCONTAS BEGIN
                           IF @V_VRTOTALAJUSNCTB <> @V_VRSOMAAJUSNCTB BEGIN
                              SET @V_VRAJUSNCTB = @V_VRAJUSNCTB + (@V_VRTOTALAJUSNCTB - @V_VRSOMAAJUSNCTB);
                           END;
                        END;
                     END;
                     IF @V_VRAJUSNCTB IS NULL BEGIN
                        SET @V_VRAJUSNCTB = 0;
                     END;
                     SET @V_VRPARTIDA = ROUND(@C_CONTAS_VRATUAPAG + @V_VRAJUSNCTB, 2);

                     IF ISNULL(@V_VRPARTIDA, 0) <> 0 BEGIN
                        SET @V_SEQPARTIDA = @V_SEQPARTIDA + 1;
                        SET @V_PARTIDAAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_SEQPARTIDA), 2);

                        SELECT @V_IDCOME = ISNULL(IDTIPOCOME, 'N'), @V_IDCCUS = IDCONTCCUS
                          FROM CONTCTBL
                         WHERE CDCONTCTBL = @V_CDCONTCTBL;

                        IF @V_IDCOME <> 'F' BEGIN
                           SET @V_IDCOME = 'N';
                           SET @V_CDREDUCONT = NULL;
                        END;

                        INSERT INTO LANCCTBTEMP
                           (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                            DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
                        VALUES
                           (@P_CDEMPRESA, @V_NRLANCTEMP, @V_DOCUMENTO, @V_PARTIDAAUX, @V_CDCONTCTBL, @V_CDHISTPADR,
                            @V_DSHISTPADR, @V_DTBAIXA, @V_VRPARTIDA * -1, @V_IDCOME, @V_CODCOMEAUX, 'PAG');
                        IF @V_CONTRAT = 'S' BEGIN
                           IF @V_IDCCUS <> 'O' BEGIN
                              SET @V_RATSEQ = 0;
                              SET @V_TOTALRATEIO = 0;
                              IF @C_CONTAS_IDCTBTPCNTBPAG <> 'S' BEGIN
                                 SELECT @V_CDCENTCUST = CDCENTCUST
                                   FROM FILIAL
                                  WHERE CDFILIAL = @C_CONTAS_CDFILIRECE;

                                 IF @V_CDCENTCUST IS NULL BEGIN
                                    SELECT @V_CDCENTCUST = CDCENTCUST
                                      FROM EMPRESA
                                     WHERE CDEMPRESA = @P_CDEMPRESA;
                                 END;


                                 SET @V_RATSEQ = @V_RATSEQ + 1;
                                 SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);

                                 INSERT INTO RATECTBTEMP
                                    (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                                 VALUES
                                    (@P_CDEMPRESA, @V_NRLANCTEMP, @V_PARTIDAAUX, @C_CONTAS_CDFILIRECE, @V_CDCENTCUST,
                                     @V_VRPARTIDA, @V_DTBAIXA, @V_RATSEQAUX);
                                 SET @V_TOTALRATEIO = @V_TOTALRATEIO + @V_VRPARTIDA;
                              END
                              ELSE BEGIN
                                 SET @V_ENTROULOOP = 'N';
                                 DECLARE C_RATEIO CURSOR FOR
                                    SELECT CDCENTCUST, CDFIRATCTPAG, VRRATCCCTPAG
                                     FROM RATCTPAGAR
                                    WHERE CDFILIAL = @C_CONTAS_CDFILIAL
                                      AND NRLANCTONF = @C_CONTAS_NRLANCTONF
                                      AND NRSEQVENPAG = @C_CONTAS_NRSEQVENPAG
                                      AND NRPARCELAPAG = @C_CONTAS_NRPARCELAPAG;
                                 OPEN C_RATEIO;
                                 FETCH NEXT FROM C_RATEIO INTO @C_RATEIO_CDCENTCUST, @C_RATEIO_CDFIRATCTPAG, @C_RATEIO_VRRATCCCTPAG;
                                 WHILE @@FETCH_STATUS = 0 BEGIN
                                    SET @V_ENTROULOOP = 'S';
                                    SET @V_RATSEQ = @V_RATSEQ + 1;
                                    SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);
                                    SET @V_VRPARTIDA = ROUND(@C_RATEIO_VRRATCCCTPAG, 2);
                                    INSERT INTO RATECTBTEMP
                                       (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                                    VALUES
                                       (@P_CDEMPRESA, @V_NRLANCTEMP, @V_PARTIDAAUX, @C_RATEIO_CDFIRATCTPAG, @C_RATEIO_CDCENTCUST,
                                        @V_VRPARTIDA, @V_DTBAIXA, @V_RATSEQAUX);
                                    SET @V_TOTALRATEIO = @V_TOTALRATEIO +  ROUND(@C_RATEIO_VRRATCCCTPAG, 2);
                                    SET @V_CDFILIAL = @C_RATEIO_CDFIRATCTPAG;
                                    SET @V_CDCENTCUST = @C_RATEIO_CDCENTCUST;
                                    FETCH NEXT FROM C_RATEIO INTO @C_RATEIO_CDCENTCUST, @C_RATEIO_CDFIRATCTPAG, @C_RATEIO_VRRATCCCTPAG;
                                 END;
                                 IF @V_ENTROULOOP = 'N' BEGIN
                                    SELECT @V_CDCENTCUST = CDCENTCUST
                                      FROM FILIAL
                                     WHERE CDFILIAL = @C_CONTAS_CDFILIRECE;

                                    IF @V_CDCENTCUST IS NULL BEGIN
                                       SELECT @V_CDCENTCUST = CDCENTCUST
                                         FROM EMPRESA
                                        WHERE CDEMPRESA = @P_CDEMPRESA;
                                    END;

                                    SET @V_RATSEQ = @V_RATSEQ + 1;
                                    SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);

                                    INSERT INTO RATECTBTEMP
                                       (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                                    VALUES
                                       (@P_CDEMPRESA, @V_NRLANCTEMP, @V_PARTIDAAUX, @C_CONTAS_CDFILIRECE, @V_CDCENTCUST,
                                        @V_VRPARTIDA, @V_DTBAIXA, @V_RATSEQAUX);
                                    SET @V_TOTALRATEIO = @V_TOTALRATEIO + ROUND(@C_CONTAS_VRATUAPAG, 2);
                                    SET @V_CDFILIAL = @C_CONTAS_CDFILIRECE;
                                    SET @V_CDCENTCUST = @V_CDCENTCUST;
                                 END;

                                 IF @V_TOTALRATEIO <> @V_VRPARTIDA BEGIN
                                    SET @V_VRPARTIDA = @V_TOTALRATEIO - @V_VRPARTIDA;
                                    SET @V_RATSEQ = @V_RATSEQ + 1;
                                    SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);
                                    INSERT INTO RATECTBTEMP
                                       (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                                    VALUES
                                       (@P_CDEMPRESA, @V_NRLANCTEMP, @V_PARTIDAAUX, @V_CDFILIAL, @V_CDCENTCUST,
                                        @V_TOTALRATEIO, @V_DTBAIXA, @V_RATSEQAUX);
                                 END;
                              END;
                           END;
                        END;
                     END;
                  END;
                  FETCH NEXT FROM C_CONTAS INTO @C_CONTAS_CDFILIAL, @C_CONTAS_NRLANCTONF, @C_CONTAS_NRSEQVENPAG, @C_CONTAS_NRPARCELAPAG,
                                             @C_CONTAS_CDFILBOL, @C_CONTAS_NRLANBOLPAG, @C_CONTAS_CDFORNECED, @C_CONTAS_CDTPCTPAGAR, @C_CONTAS_CDCONTCTBL,
                                             @C_CONTAS_CDHISTPADR, @C_CONTAS_DSHISTPADR, @C_CONTAS_CDFILIRECE, @C_CONTAS_NRNOTAFISC,
                                             @C_CONTAS_VRATUAPAG, @C_CONTAS_IDCTBTPCNTBPAG, @C_CONTAS_VRBOLPAG, @C_CONTAS_QTCONTAS,
                                             @C_CONTAS_IDTPCTPAGAR, @C_CONTAS_CDEMPRESA, @C_CONTAS_VRORIGPAG;

               END;
               CLOSE C_CONTAS;
               DEALLOCATE C_CONTAS;
            END;

            /* ROTINA DE CONTABILIZAO DOS AJUSTES */
            DECLARE AJUSTES CURSOR FOR
               SELECT BO.NRLANBOLPAG, BO.CDFILIBAIPAG, NF.CDFILIRECE, AJ.CDAJUCTPAG,
                      BX.CDREDUCONT, BO.CDFORNECED, AJ.VRAJBOLPAG, IDAJUCTPAG, BO.VRBOLPAG,
                      CT.NRLANCTONF, CT.CDFILIAL, HP.CDHISTPADR, CT.NRSEQVENPAG, CT.NRPARCELAPAG,
                      CT.VRATUAPAG, TP.CDCONTCTBL
                 FROM BAIXAPAGA BX, BOLETPAGAR BO, AJBOLPAG AJ, CONTAPAGAR CT,
                      NOTAFISCAL NF, TIPOAJPAGAR TP LEFT JOIN HISTPADR HP
                                                             ON HP.CDHISTPADR = TP.CDHISTPADR
                WHERE BX.CDFILIAL = @P_CDFILIAL
                  AND BX.NRBAIXAPAG = @P_NRBAIXA
                  AND BX.CDFILIAL = BO.CDFILIBAIPAG
                  AND BX.NRBAIXAPAG = BO.NRBAIXAPAG
                  AND BO.CDFILIAL = AJ.CDFILIAL
                  AND BO.NRLANBOLPAG = AJ.NRLANBOLPAG
                  AND BO.CDFILIAL = ct.CDFILIBPAG
                  AND BO.NRLANBOLPAG = CT.NRLANBOLPAG
                  AND CT.CDFILIAL = NF.CDFILIAL
                  AND CT.NRLANCTONF = NF.NRLANCTONF
                  AND AJ.CDAJUCTPAG = TP.CDAJUCTPAG
                  AND TP.IDCTBAJCTPAG = 'S';
            OPEN AJUSTES;
            FETCH NEXT FROM AJUSTES INTO @AJUSTES_NRLANBOLPAG, @AJUSTES_CDFILIBAIPAG, @AJUSTES_CDFILIRECE,
                                        @AJUSTES_CDAJUCTPAG, @AJUSTES_CDREDUCONT, @AJUSTES_CDFORNECED,
                                        @AJUSTES_VRAJBOLPAG, @AJUSTES_IDAJUCTPAG, @AJUSTES_VRBOLPAG,
                                        @AJUSTES_NRLANCTONF, @AJUSTES_CDFILIAL, @AJUSTES_CDHISTPADR,
                                        @AJUSTES_NRSEQVENPAG, @AJUSTES_NRPARCELAPAG, @AJUSTES_VRATUAPAG, @AJUSTES_CDCONTCTBL;
            WHILE @@FETCH_STATUS = 0 BEGIN
               IF @AJUSTES_IDAJUCTPAG = 'A' BEGIN
                  SET @V_FATOR = -1;
               END
               ELSE BEGIN
                  SET @V_FATOR = 1;
               END;

               EXEC CTB_HIST_PAG @AJUSTES_CDHISTPADR, @AJUSTES_CDFILIAL, @AJUSTES_NRLANCTONF, @AJUSTES_NRSEQVENPAG, @AJUSTES_NRPARCELAPAG, @AJUSTES_CDAJUCTPAG, @P_DSHISTPADR = @V_DSHISTPADR OUTPUT;

               SELECT @V_CDCENTCUST = CDCENTCUST
                 FROM FILIAL
                WHERE CDFILIAL = @AJUSTES_CDFILIRECE;

               IF @V_CDCENTCUST IS NULL BEGIN
                  SELECT @V_CDCENTCUST = CDCENTCUST
                    FROM EMPRESA
                   WHERE CDEMPRESA = @P_CDEMPRESA;
               END;

               SET @V_CDCONTCTBL = @AJUSTES_CDCONTCTBL;

               SELECT @V_IDCOME = ISNULL(IDTIPOCOME, 'N'), @V_IDCCUS = IDCONTCCUS
                 FROM CONTCTBL
                WHERE CDCONTCTBL = @V_CDCONTCTBL;

               IF @V_IDCOME = 'B' BEGIN
                  SET @V_CODCOMEAUX = @AJUSTES_CDREDUCONT;
               END
               ELSE IF @V_IDCOME = 'C' BEGIN
                  SET @V_CODCOMEAUX = @AJUSTES_CDFORNECED;
               END
               ELSE BEGIN
                  SET @V_IDCOME = 'N';
                  SET @V_CODCOMEAUX = NULL;
               END;

               IF @V_SEQPARTIDA IS NULL BEGIN
                  SET @V_SEQPARTIDA = 0;
               END;

               SET @V_SEQPARTIDA = @V_SEQPARTIDA + 1;
               SET @V_PARTIDAAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_SEQPARTIDA), 2);
               SET @V_VRAJUSTE = (@AJUSTES_VRATUAPAG  * 100) / @AJUSTES_VRBOLPAG;
               SET @V_VRAJUSTE = ROUND(((@AJUSTES_VRAJBOLPAG * @V_VRAJUSTE) / 100) * @V_FATOR, 2);

               INSERT INTO LANCCTBTEMP
                  (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                   DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
               VALUES
                  (@P_CDEMPRESA, @V_NRLANCTEMP, @V_DOCUMENTO, @V_PARTIDAAUX, @V_CDCONTCTBL, @V_CDHISTPADR,
                  @V_DSHISTPADR,  @V_DTBAIXA, @V_VRAJUSTE, @V_IDCOME, @V_CODCOMEAUX, 'PAG');

               SET @V_TOTAJUSTE = @V_VRAJUSTE * @V_FATOR;

               IF @V_CONTRAT = 'S' BEGIN
                  IF @V_IDCCUS <> 'O' BEGIN
                     SET @V_TOTRATAJ = 0;
                     SET @V_RATSEQ = 0;
                     SELECT @V_COUNT = COUNT(*)
                       FROM RATTpajp
                      WHERE CDAJUCTPAG = @AJUSTES_CDAJUCTPAG;

                     IF @V_COUNT <> 0 BEGIN
                        DECLARE RATAJ CURSOR FOR
                           SELECT CDCENTCUST, CDFIRATTpajp, CDFILIAL, VRPERATTpajp
                             FROM RATTpajp
                            WHERE CDAJUCTPAG = @AJUSTES_CDAJUCTPAG;
                        OPEN RATAJ;
                        FETCH NEXT FROM RATAJ INTO @RATAJ_CDCENTCUST, @RATAJ_CDFIRATTpajp,
                                                   @RATAJ_CDFILIAL, @RATAJ_VRPERATTpajp;
                        WHILE @@FETCH_STATUS = 0 BEGIN
                           SET @V_VRAJUSTE = (@V_TOTAJUSTE * @RATAJ_VRPERATTpajp) / 100;

                           SET @V_RATSEQ = @V_RATSEQ + 1;
                           SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);
                           SELECT @V_CDFILIAL = CASE @RATAJ_CDFIRATTpajp WHEN '----' THEN @AJUSTES_CDFILIRECE ELSE @RATAJ_CDFIRATTpajp END;
                           INSERT INTO RATECTBTEMP
                              (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP,
                               CDFILIAL, CDCENTCUST,
                               VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                           VALUES
                              (@P_CDEMPRESA, @V_NRLANCTEMP, @V_PARTIDAAUX,
                               @V_CDFILIAL, @RATAJ_CDCENTCUST,
                               @V_VRAJUSTE, @V_DTBAIXA, @V_RATSEQAUX);

                           SET @V_TOTRATAJ = @V_TOTRATAJ + @V_VRAJUSTE;
                           SET @V_CDCENTCUST = @RATAJ_CDCENTCUST;
                           FETCH NEXT FROM RATAJ INTO @RATAJ_CDCENTCUST, @RATAJ_CDFIRATTpajp,
                                                   @RATAJ_CDFILIAL, @RATAJ_VRPERATTpajp;
                        END;
                     END
                     ELSE BEGIN
                        SET @V_RATSEQ = @V_RATSEQ + 1;
                        SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);
                        SELECT @V_CDCENTCUST = CDCENTCUST
                          FROM FILIAL
                         WHERE CDFILIAL = @AJUSTES_CDFILIRECE;

                        IF @V_CDCENTCUST IS NULL BEGIN
                           SELECT @V_CDCENTCUST = CDCENTCUST
                             FROM EMPRESA
                            WHERE CDEMPRESA = @P_CDEMPRESA;
                        END;

                        SET @V_VRAJUSTE = ROUND(@V_VRAJUSTE * @V_FATOR, 2);
                        INSERT INTO RATECTBTEMP
                           (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                        VALUES
                           (@P_CDEMPRESA, @V_NRLANCTEMP, @V_PARTIDAAUX, @AJUSTES_CDFILIRECE, @V_CDCENTCUST,
                           @V_VRAJUSTE, @V_DTBAIXA, @V_RATSEQAUX);

                        SET @V_TOTRATAJ = @V_TOTRATAJ + (@V_VRAJUSTE * @V_FATOR);
                        SET @V_CDFILIAL = @AJUSTES_CDFILIRECE;
                        SET @V_CDCENTCUST = @V_CDCENTCUST;
                     END;
                     IF @V_TOTRATAJ <> @V_TOTAJUSTE BEGIN
                        SET @V_RATSEQ = @V_RATSEQ + 1;
                        SET @V_TOTRATAJ = @V_TOTRATAJ - @V_TOTAJUSTE;
                        UPDATE RATECTBTEMP
                           SET VRRATECTBTEMP = VRRATECTBTEMP + @V_TOTRATAJ
                         WHERE NRSEQCTBTEMP = @V_PARTIDAAUX
                           AND CDFILIAL = @V_CDFILIAL
                           AND CDCENTCUST = @V_CDCENTCUST
                           AND NRLANCCTBTEMP = @V_NRLANCTEMP
                           AND CDEMPRESA = @P_CDEMPRESA;
                     END;
                  END;
               END;
               FETCH NEXT FROM AJUSTES INTO @AJUSTES_NRLANBOLPAG, @AJUSTES_CDFILIBAIPAG, @AJUSTES_CDFILIRECE,
                                            @AJUSTES_CDAJUCTPAG, @AJUSTES_CDREDUCONT, @AJUSTES_CDFORNECED,
                                            @AJUSTES_VRAJBOLPAG, @AJUSTES_IDAJUCTPAG, @AJUSTES_VRBOLPAG,
                                            @AJUSTES_NRLANCTONF, @AJUSTES_CDFILIAL, @AJUSTES_CDHISTPADR,
                                            @AJUSTES_NRSEQVENPAG, @AJUSTES_NRPARCELAPAG, @AJUSTES_VRATUAPAG, @AJUSTES_CDCONTCTBL;
            END;
            CLOSE AJUSTES;
            DEALLOCATE AJUSTES;
         END;
      END;

      /*VERIFICACAO DE ERROS NAS PARTIDAS E NO LANCAMENTO CONTABIL*/
      EXEC VERIFICA_ERRO_CTB @V_NRLANCTEMP, @P_CDEMPRESA;
      SELECT @V_COUNT = COUNT(*)
        FROM ERROCTBTEMP
       WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
         AND CDEMPRESA = @P_CDEMPRESA;

      IF @V_COUNT = 0 BEGIN
         UPDATE BAIXAPAGA
            SET NRLCTBBPAG = @V_NRLANCTEMP
          WHERE NRBAIXAPAG = @P_NRBAIXA
            AND CDFILIAL   = @P_CDFILIAL;
      END;

      EXEC GRAVA_LANC_CTB @V_NRLANCTEMP, @P_CDEMPRESA;
      SET @P_NRLANCCTB = @V_NRLANCTEMP;
   END;
END;
GO


-- VERSAO --
EXEC TEKNISA.ATUVEROBJ 'CTB_PAG_BAIXA','5.50.000';
GO

